"""
copyright ICSI
"""

import sys
import os

"""
input: list of files
output: string with hyperlinks to files
"""
def makeFileLinkString(fileList):
    linkstring = ""
    for file in fileList:
        linkstring = linkstring+ "<a href=\"http://"+file+"\">"+file+"</a>, \n"
    linkstring = linkstring[0:-3]
    return linkstring
    
"""
input: dicts
output: html code with hyperlinks to URLs from which info in dict were extracted
"""
def makeFootNotes(dict):
    footNotesString = ""
    for i, url in enumerate(dict["URLs"]):
        footNotesString = footNotesString +"<a href=\"http://"+url+"\">["+str(i)+"]</a>\n"
    return footNotesString

"""
input: name, value
output: url for ask querry of the name and the value
"""
def makeAskSearchURL(name, value):
    querycontent = "%22"+name+"%22+%22"+value+"%22"
    querycontent = querycontent.replace(" ", "+")
    return "http://www.ask.com/web?q="+querycontent
    
"""
Creates body of html file
"""
def htmlClusters(sortedkeys, clusterIDToBigrams, clusterIDToEmployHist, clusterIDToEduHist, clusterIDToEmails,\
                   clusterIDToMiddleName, clusterIDToSelectedFiles, clusterIDToLinkTitles, clusterIDToFileList, clusterIDToRepFile, \
                   clusterIDToImageTag, numFeaturesToShow, name, nonPP):
    htmlPage = "<FONT SIZE=\"+2\"><b>Search Results for "+name+"</font><br>"
    htmlPage = htmlPage+"\n"+ "<HR SIZE=\"1\"><br><br>\n"
    counter = 0
    for id in sortedkeys:
        """
        Add middle name to name
        """
        tagstring = ""
        middleName = " "
        if len(clusterIDToMiddleName[id]) > 0:
            middleName = middleName+clusterIDToMiddleName[id][0]["Middle Name"]+" "
        querycontent = "%22"+name.split()[0]+middleName+name.split()[1]+"%22"
        querycontent = querycontent.replace(" ", "+")
        asksearchurl = "http://www.ask.com/web?q="+querycontent
        tagstring = tagstring +"<a href=\""+asksearchurl+"\">"+name.split()[0]+middleName+name.split()[1]+"</a>\n"
        htmlPage = htmlPage+"\n"+ "<FONT SIZE=\"+1\"><b>"+tagstring+" (Cluster: "+str(counter)+ ")</FONT><br><br>"

        """
        Add image
        """
        if clusterIDToImageTag[id] != "":
            htmlPage = htmlPage+"\n"+clusterIDToImageTag[id]+"<br>"

        """
        Add rep file
        """   
        htmlPage = htmlPage+"\n"+ "Representative file: <a href=\"http://"+clusterIDToRepFile[id][0]+"\">"+clusterIDToRepFile[id][1]+\
                   "</a><br>"
        htmlPage = htmlPage+"\n"+ "<FONT SIZE=\"-1\">"

        """
        Add selected files
        """
        if len(clusterIDToSelectedFiles[id]) > 0:
            htmlPage = htmlPage+"\n"+ "<br>Selected links:&nbsp;&nbsp;"
            tagstring = ""
            if clusterIDToSelectedFiles[id].has_key("Wikipedia"):
                tagstring = tagstring +"&nbsp;&nbsp;<a href=\"http://"+clusterIDToSelectedFiles[id]["Wikipedia"]+"\">Wikipedia</a>,\n"
            if clusterIDToSelectedFiles[id].has_key("My Space"):
                tagstring = tagstring +"&nbsp;&nbsp;<a href=\"http://"+clusterIDToSelectedFiles[id]["My Space"]+"\">My Space</a>,\n"
            if clusterIDToSelectedFiles[id].has_key("Flickr"):
                tagstring = tagstring +"&nbsp;&nbsp;<a href=\"http://"+clusterIDToSelectedFiles[id]["Flickr"]+"\">Flickr</a>,\n"    
            tagstring = tagstring[0:-2]+"<br>"
            htmlPage = htmlPage+"\n"+ tagstring

        """
        Add bigrams
        Show bigrams with the highest value for:
             # of clusters bigram appears in + (# of times bigram appears) / (max # of times bigram appears + 1)
        """
        if len(clusterIDToBigrams[id]) > 0: htmlPage = htmlPage+"\n"+ "<br>Search for "+name+" and...<br>"
        tagstring = ""
        for pair in sorted([(v[1]+v[0]/(max(clusterIDToBigrams[id].values()[0])+1.0), k) \
                                               for k,v in clusterIDToBigrams[id].items()], reverse=True)[0:numFeaturesToShow]: 
            asksearchurl = makeAskSearchURL(name, pair[1])
            tagstring = tagstring +"&nbsp;&nbsp;<a href=\""+asksearchurl+"\">"+pair[1]+"</a>,\n"
        tagstring = tagstring[0:-2]+"<br>"
        htmlPage = htmlPage+"\n"+ tagstring

        """
        Add employment history
        """
        if clusterIDToEmployHist[id] != []:
            htmlPage = htmlPage+"\n"+ "<br>Employment History:<br>"
            tagstring = ""
            for employDict in clusterIDToEmployHist[id]:
                if employDict.has_key("Profession"):
                    asksearchurl = makeAskSearchURL(name, employDict["Profession"])
                    tagstring = tagstring +"&nbsp;&nbsp;Profession:&nbsp;&nbsp;<a href=\""+asksearchurl+"\">"+employDict["Profession"]+\
                                "</a>\n" + makeFootNotes(employDict)+"<br>"
                if employDict.has_key("Employer"):
                    asksearchurl = makeAskSearchURL(name, employDict["Employer"])
                    tagstring = tagstring +"&nbsp;&nbsp;Employer:&nbsp;&nbsp;<a href=\""+asksearchurl+"\">"+employDict["Employer"]+\
                                "</a>\n" + makeFootNotes(employDict)+"<br>"
                if employDict.has_key("Department"):
                    tagstring = tagstring +"&nbsp;&nbsp;Department:"
                    for dept in employDict["Department"]:
                        asksearchurl = makeAskSearchURL(name, dept)
                        tagstring = tagstring +"&nbsp;&nbsp;<a href=\""+asksearchurl+"\">"+dept+"</a>\n" + makeFootNotes(employDict)+","
                    tagstring = tagstring[:-1] +"<br>"
                tagstring = tagstring +"<br>"       
            htmlPage = htmlPage+"\n"+ tagstring

        """
        Add education info
        """
        if clusterIDToEduHist[id] != []:
            htmlPage = htmlPage+"\n"+ "<br>Education:<br>"
            tagstring = ""
            for eduDict in clusterIDToEduHist[id]:
                if eduDict.has_key("Degree"):
                    tagstring = tagstring +"&nbsp;&nbsp;Degree:"
                    for deg in eduDict["Degree"]:
                        asksearchurl = makeAskSearchURL(name, deg)
                        tagstring = tagstring +"&nbsp;&nbsp;<a href=\""+asksearchurl+"\">"+deg+"</a>\n" + makeFootNotes(employDict)+","
                    tagstring = tagstring[:-1] +"<br>"
                tagstring = tagstring +"<br>" 
            htmlPage = htmlPage+"\n"+ tagstring

        """
        Add emails
        """
 	if len(clusterIDToEmails[id]) > 0:
            htmlPage = htmlPage+"\n"+ "<br>Emails:<br>"
            tagstring = ""
            for emailDict in clusterIDToEmails[id]:
                asksearchurl = makeAskSearchURL(name, emailDict["Email"])
                tagstring = tagstring +"&nbsp;&nbsp;<a href=\""+asksearchurl+"\">"+emailDict["Email"]+"</a>\n"+makeFootNotes(emailDict)+","
            tagstring = tagstring[0:-1]+"<br>" 
            htmlPage = htmlPage+"\n"+ tagstring

        """
        Add Link Titles
        """
        if len(clusterIDToLinkTitles[id]) > 0:
            htmlPage = htmlPage+"\n"+ "<br>Links:<br>"
            tagstring = ""
            for url, title in clusterIDToLinkTitles[id].iteritems():
                tagstring = tagstring +"<a href=\""+url+"\">"+title+"</a>,\n"
            tagstring = tagstring[0:-2]+"<br>"
            htmlPage = htmlPage+"\n"+ tagstring

        """
        if nonPP=True, add Middle Names
        """
        if nonPP == True and len(clusterIDToMiddleName[id]) > 0:
            htmlPage = htmlPage+"\n"+ "<br>Middle Names:<br>"
            tagstring = ""
            for middleNameDict in clusterIDToMiddleName[id]:
                asksearchurl = makeAskSearchURL(name, middleNameDict["Middle Name"])
                tagstring = tagstring +"&nbsp;&nbsp;<a href=\""+asksearchurl+"\">"+middleNameDict["Middle Name"]+"</a>\n" + \
                            makeFootNotes(middleNameDict)+","
            tagstring = tagstring[0:-1]+"<br>"
            htmlPage = htmlPage+"\n"+ tagstring

        """
        if nonPP=True, add URLs in cluster
        """
        if nonPP==True and len(clusterIDToFileList[id]) > 1:
            htmlPage = htmlPage+"\n"+ "<br>"
            htmlPage = htmlPage+"\n"+ str(len(clusterIDToFileList[id]))+" relevant documents from the top 100 hits on ask.com:<br>"
            linkstring = makeFileLinkString(clusterIDToFileList[id])
            htmlPage = htmlPage+"\n"+ linkstring
        
        htmlPage = htmlPage+"\n"+ "</font><HR SIZE=\"1\"><br>\n\n"
        counter = counter + 1
    return htmlPage
    
def makeHTML(clusterIDToBigrams, clusterIDToEmployHist, clusterIDToEduHist, clusterIDToEmails, clusterIDToMiddleName, \
               clusterIDToSelectedFiles, clusterIDToLinkTitles, clusterIDToFileList, clusterIDToRepFile, clusterIDToImageTag, \
               fileNameToRank, numFeaturesToShow, name, removedFiles, nonPP):
    htmlPage = "<html><head><style type=\"text/css\"><!--A{text-decoration:none}--></style></head>"
    sortedkeys = []
    for pair in sorted([(fileNameToRank[v[0]], k) for k,v in clusterIDToRepFile.items()]):  #sort clusters based on rep file rank
        sortedkeys.append(pair[1])    
    htmlPage = htmlPage+"\n"+ htmlClusters(sortedkeys, clusterIDToBigrams, clusterIDToEmployHist, clusterIDToEduHist, clusterIDToEmails,\
                                           clusterIDToMiddleName, clusterIDToSelectedFiles, clusterIDToLinkTitles, clusterIDToFileList, \
                                           clusterIDToRepFile, clusterIDToImageTag, numFeaturesToShow, name, nonPP)
    htmlPage = htmlPage+"\n"+ "<br>"+str(len(removedFiles))+" other results:"
    htmlPage = htmlPage+"\n"+ makeFileLinkString(removedFiles)
    htmlPage = htmlPage+"\n"+ "</html>"
    return htmlPage
