"""
copyright ICSI
"""

import sys
import os
import re
from utils import *
from BeautifulSoup import BeautifulSoup, CData, Comment, NavigableString, Declaration, ProcessingInstruction, Tag

"""
input: html code
output: string list of links in html code
"""
def processLinks(page):
    removeHTMLCodes = re.compile("\&[\S]{2,6}\;")
    soup = BeautifulSoup(page)
    links = soup.findAll("a")
    linkstring = ""
    for link in links:
        if link.has_key('href') and re.compile("http://", re.IGNORECASE).match(link['href']) != None:
            linkstring = linkstring + link['href'] + "\n"
    linkstring = linkstring.encode('ascii', 'replace')
    return linkstring

def pagegetter(name, numhits):
    """
    Make folders
    """
    dirname = name.replace(" ", "-")
    if not os.path.exists("../data/"+dirname):
        os.system("mkdir ../data/"+dirname)
    if not os.path.exists("../data/"+dirname+"/html"):
        os.system("mkdir ../data/"+dirname+"/html")
    else:
        filenames = os.listdir("../data/"+dirname+"/html/")
        for filename in filenames:
            os.remove("../data/"+dirname+"/html/"+filename)
    if not os.path.exists("../data/"+dirname+"/links"):
        os.system("mkdir ../data/"+dirname+"/links")
    else:
        filenames = os.listdir("../data/"+dirname+"/links/")
        for filename in filenames:
            os.remove("../data/"+dirname+"/links/"+filename)
    if not os.path.exists("../data/"+dirname+"/text"):
        os.system("mkdir ../data/"+dirname+"/text")
    else:
        filenames = os.listdir("../data/"+dirname+"/text/")
        for filename in filenames:
            os.remove("../data/"+dirname+"/text/"+filename)
    """
    form the search query
    """
    name = name.replace(" ", "%20")
    asksearchurl = "http://xml.teoma.com/e?qcat=0&ref=&f=0&i=0&s=0&t=%22" +\
                   name + "%22&p=0&y=0&a=1&cl=ce5001fd&cid=a&ss=&b=&h=&u="+ \
                   str(numhits)+"&nl=&vid=&teoma=&ps=&psize=&w=&ddopts=&kw=0&sid=a&chid=a&did=us&tid="

    """
    get the results from teoma
    """
    f = urllib.urlopen(asksearchurl)
    page = f.read()
    f.close()

    """
    parse the page for the URLs
    """
    urls = []
    for line in page.split("\n"):
        if line.find("<URL>") != -1 and line.find("<RESULT") != -1 :
            temp = line.split("<URL>")
            urlline = temp[1].split("</URL>")
            urls.append(urlline[0])

    """
    Process and save text, links, html code, and querry rank
    """
    rankingstring = ""  #url querry rank string
    counter = 1  #url querry rank
    for url in urls:
        try:
            page = getURLPage(url)
            osSafeURL = urlToOsSafeURL(url)
            links = processLinks(page)
            os.system('lynx -dump -nolist -width=99999 \"'+url.replace("$","\$")+'\" > \"../data/'+dirname+'/text/'+osSafeURL.replace("$","\$")+'\"')
            writeStringToFile(page, "../data/"+dirname+"/html/"+osSafeURL)
            writeStringToFile(links, "../data/"+dirname+"/links/"+osSafeURL)
            rankingstring = rankingstring + url+" "+str(counter)+"\n"
            counter = counter + 1
        except:
            print "Unexpected error:", sys.exc_info()[0], " on file: "+url
    writeStringToFile(rankingstring, "../data/"+dirname+"/rankings.txt")





