"""
copyright ICSI
"""

import sys
import os
from utils import *
from processInfo import *
from processBigrams import *
from processLinks import *

"""
Combines 2 clusters if one of the following is true:
1. Clusters have 2 links in common or the common links have counts greater than 2
2. Clusters have 5 bigrams in common or the common bigram have counts greater than 10
3. Clusters have a common middle name
3. Clusters have a common email
"""
def cluster(minCommonBigrams, minCommonBigramMinSum, minCommonLinks, minCommonLinkMinSum, clusterIDToFileList, clusterIDToBigrams, \
            clusterIDToWordSetList, clusterIDToLinks, clusterIDToEmployHist, clusterIDToEduHist, clusterIDToEmails, clusterIDToMiddleName,\
            lastname):
    clusteringOccured = 1
    while clusteringOccured == 1:  #start clustering process over after each pair of clusters are combined
	clusteringOccured = 0
	for clusterID in clusterIDToBigrams:
		for possibleIntersectID in clusterIDToBigrams:
                    if possibleIntersectID != clusterID:
                        #Find common bigrams, links, middle names, and emails in the 2 clusters 
                        cbc = commonBigramCount(clusterIDToBigrams[clusterID], clusterIDToBigrams[possibleIntersectID])
                        cbms = commonBigramMinSum(clusterIDToBigrams[clusterID], clusterIDToBigrams[possibleIntersectID])
                        clc = commonLinkCount(clusterIDToLinks[clusterID], clusterIDToLinks[possibleIntersectID])
                        clms = commonLinkMinSum(clusterIDToLinks[clusterID], clusterIDToLinks[possibleIntersectID])
                        cmn = commonMiddleName(clusterIDToMiddleName[clusterID], clusterIDToMiddleName[possibleIntersectID])
                        cem = commonEmail(clusterIDToEmails[clusterID], clusterIDToEmails[possibleIntersectID])

                        #cluster if one of the requirements stated above is true
                        if commonURL(clusterIDToFileList[clusterID], clusterIDToFileList[possibleIntersectID], lastname) or \
                               cbc >= minCommonBigrams or cbms >= minCommonBigramMinSum or \
                               clc >= minCommonLinks or clms >= minCommonLinkMinSum or \
                               cmn >= 1 or cem >= 1:
                            clusteringOccured = 1
                            #append the information from the 2nd cluster to the first
                            bigramCounterUnion(clusterIDToBigrams[clusterID], clusterIDToBigrams[possibleIntersectID])
                            linkCounterUnion(clusterIDToLinks[clusterID], clusterIDToLinks[possibleIntersectID])
                            emailDictUnion(clusterIDToEmails[clusterID], clusterIDToEmails[possibleIntersectID])
                            middleNameDictUnion(clusterIDToMiddleName[clusterID], clusterIDToMiddleName[possibleIntersectID])
                            empHistDictUnion(clusterIDToEmployHist[clusterID], clusterIDToEmployHist[possibleIntersectID])
                            eduHistDictUnion(clusterIDToEduHist[clusterID], clusterIDToEduHist[possibleIntersectID])
                            clusterIDToFileList[clusterID].extend(clusterIDToFileList[possibleIntersectID])
                            clusterIDToWordSetList[clusterID].extend(clusterIDToWordSetList[possibleIntersectID])

                            #remove the information from the 2nd cluster
                            del clusterIDToBigrams[possibleIntersectID]
                            del clusterIDToLinks[possibleIntersectID]
                            del clusterIDToEmails[possibleIntersectID]
                            del clusterIDToMiddleName[possibleIntersectID]
                            del clusterIDToFileList[possibleIntersectID]
                            del clusterIDToEmployHist[possibleIntersectID]
                            del clusterIDToEduHist[possibleIntersectID]
                            del clusterIDToWordSetList[possibleIntersectID]
                            break
		if clusteringOccured == 1: 
                    break
