"""
copyright ICSI
"""

import sys
import os
import re
from utils import *

"""
input first and last name, path to data
output: list of urls from data that are homepages
Webpage is a homepage if:
     URL contains the persons first or last name
     Page text contains the word homepage within 3 words of the persons last name
     Page title contains the persons first or last name  
"""
def getpossiblehomepages(firstname, lastname, pathprefix):
	filenames = os.listdir(pathprefix+"/html/")
	homepageintext = re.compile(lastname+"([']s)?\s+(\S+\s+){,3}homepage|homepage\s+(\S+\s+){,3}"+lastname,re.IGNORECASE)
	homepagelist = []
	
	for filename in filenames:
		if filename.lower().find(lastname.lower()) != -1 or filename.lower().find(firstname.lower()) != -1:
			homepagelist.append(osSafeURLToURL(filename)[7:])
			continue
		fileText = readFile(pathprefix+"/text/"+filename)
		if homepageintext.search(fileText) != None:
			homepagelist.append(osSafeURLToURL(filename)[7:])
			continue
		fileHTML = readFile(pathprefix+"/html/"+filename)

		title = ""
		titlebegin = re.compile("<title>", re.IGNORECASE).search(fileHTML)
		titleend = re.compile("</title>", re.IGNORECASE).search(fileHTML)
		if titlebegin != None and titleend != None:
			titleBeginPos = fileHTML.find(titlebegin.group(0))
			titleEndPos = fileHTML.find(titleend.group(0))
			title = removeExtraWhiteSpace(fileHTML[titleBeginPos+7:titleEndPos])		
		if title.lower().find(lastname.lower()) != -1 or title.lower().find(firstname.lower()) != -1:
			homepagelist.append(osSafeURLToURL(filename)[7:])
	return homepagelist
