"""
copyright ICSI
"""

import copy
from utils import *

badBigramlist = wordFileToList("../lists/stopbigrams.txt")  #list of bigrams to ignore

"""
input: bigram dict
output: bigram dict with bigrams in badBigramList removed
"""
def removeBadBigrams(bigramCounter):
    for bigram in badBigramlist:
        if bigramCounter.has_key(bigram):
            del bigramCounter[bigram]
    return bigramCounter

"""
input: 2 bigram dicts
output: a new dictionary with the union of the keys of dict1 and dict2 and the sum of the values for those keys
"""
def bigramDictUnion(dict1, dict2):
    uniondict = copy.deepcopy(dict1)
    for key in dict2:
        if uniondict.has_key(key):
            uniondict[key] = [uniondict[key][0] + dict2[key][0], 1]
        else:
            uniondict[key] = [dict2[key][0], 1]
    return uniondict    

"""
input: file text, stop word list
output: bigram dict
"""
def extractBigramFeatureCounts(content, stopwordset):
    #replace "x.com" with "x dotcom"
    dotComRE = re.compile(r'(\S+[^*])\s+[*]PERIOD[*]\s+com', re.IGNORECASE)
    matches = dotComRE.finditer(content)
    for match in matches:
        if match != None:
            content = content.replace(match.group(0), match.group(1)+" dotcom")

    #find all group of words inbetween barriers
    tokens = content.split()
    wordSetList = []
    wordSet = ""
    for token in tokens:
        token = token.lower()
        if len(token) < 2 or token.find("*") != -1 or token.find("&") != -1 or token.find("%") != -1 or token.find("_") !=-1\
            or token.find("#") != -1 or hasDigitCharacter(token) or token.find("+") != -1 or token == "" or token in stopwordset:
            if wordSet != "":
                wordSetList.append(wordSet.strip())
                wordSet = ""
        else:
            wordSet = wordSet+token+" "
    if wordSet != "":
        wordSetList.append(wordSet.strip())

    #extract bigrams from words inbetween barriers
    bigramcounter = {}
    for wordSet in wordSetList:
        words = wordSet.split()
        for i, word in enumerate(words):
            if i < len(words)-1:
                bigram = word + " " + words[i+1]
                if bigramcounter.has_key(bigram):
                    bigramcounter[bigram][0] = bigramcounter[bigram][0] + 1
                else:
                    bigramcounter[bigram] = [1, 1]
    return bigramcounter, wordSetList

"""
input: bigram dict, count
output: # of bigrams with counts greater than count
"""
def bigramCountsGreaterThan(bigramCounter, count):
    numFound = 0
    for key, value in bigramCounter.items():
        if value[0] > count:
            numFound = numFound + 1
    return numFound

"""
input: bigram dict, count
removes bigrams with counts less than count
"""
def removeBigramCountsLessThan(bigramCounter, count):
    toRemoveList = []
    for key, value in bigramCounter.items():
        if value[0] < count:
            toRemoveList.append(key)
    for key in toRemoveList:
        del bigramCounter[key]

"""
input: 2 bigram dicts
output: # of common bigrams between the dictionaries
"""
def commonBigramCount(bigramCounter1, bigramCounter2):
    ckc = 0
    for key in bigramCounter2:
        if bigramCounter1.has_key(key):
            ckc = ckc + 1
    return ckc

"""
input: 2 bigram dicts
output: the sum of the min value for common bigrams between the dictionaries.
"""
def commonBigramMinSum(bigramCounter1, bigramCounter2):
    ckms = 0
    for key in bigramCounter2:
        if bigramCounter1.has_key(key):
            ckms  = ckms + min(bigramCounter1[key][0], bigramCounter2[key][0])
    return ckms

"""
input: 2 bigram dicts
adds the values of the 2nd bigram dict to the first
"""
def bigramCounterUnion(bigramCounter1, bigramCounter2):
	for key in bigramCounter2:
		if bigramCounter1.has_key(key):
			bigramCounter1[key][0] = bigramCounter1[key][0] + bigramCounter2[key][0]
                        bigramCounter1[key][1] = bigramCounter1[key][1] + bigramCounter2[key][1]
		else:
			bigramCounter1[key] = bigramCounter2[key]
                        
