"""
copyright ICSI
"""

import sys
sys.path.append("../utils")
sys.path.append("../makeWebPages")
sys.path.append("../pageGetter")
sys.path.append("../pipeline")
import os
from utils import *
from pagegetter import *
from pipeline import *
from buildindex import *

"""
Default settings if arguments are not passed in
"""
namelist = []
forceRePageGetting = False
forceReClustering = False

"""
Deal with arguments passed in:
    name = Process name instead of names on namelist
    -g = force re-pagegetting
    -c force re-clustering
"""
for argv in sys.argv[1:]:
    print argv
    if argv == "-g":
        forceRePageGetting = True
    elif argv == "-c":
        forceReClustering = True
    else:
        namelist = argv.split(", ")

if namelist == []:  #if no names passed in process all names in namesToCluster
    namelist = wordFileToList("namesToCluster")

"""
Find names for which data has already been gotten
"""
pageGottenNames = os.listdir("../data")

"""
Find names for which data has already been clustered
"""
filesInHTMLDir = os.listdir("../webPages/")
clusteredNames = []
for file in filesInHTMLDir:
    if file.find(".html") != -1 and file.find("_pp.html") == -1 and file.find("#") == -1 and file.find("~") == -1 and file.find("index") == -1:
        file = file.replace("_", " ")
        clusteredNames.append(file[:-5])

"""

"""
for name in namelist:
    """
    Get data for name
    """
    if pageGottenNames.count(name.replace(" ", "-")) > 0 and forceRePageGetting == False:
        print "Already got pages for: "+name
    else:
        pagegetter(name, 100)
        os.system("chmod -R g+rw ../data/"+name.replace(" ", "-"))
        print "Completed the download of the pages for: "+name

    """
    Cluster data for name
    """    
    if clusteredNames.count(name) > 0 and forceReClustering == False:
        print "Already clustered pages for: "+name
    else:
        pipeline(name)
        print "Completed the clustering of the pages for: "+name

    """
    Create index for web pages
    """
    writeStringToFile(buildindex(), "../webPages/index.html")
    os.chmod("../webPages/index.html", 0664)
 
